require 'rails_helper'

module Mks
  module Rate
    RSpec.describe ServiceType, type: :model do
      it 'has a valid factory' do
        expect(create(:service_type)).to be_valid
      end

      it 'is invalid with no code' do
        expect(build(:service_type, code: nil)).not_to be_valid
      end

      it 'is invalid with no name' do
        expect(build(:service_type, name: nil)).not_to be_valid
      end

      it 'is invalid with duplicate code' do
        st = create(:service_type)
        expect(build(:service_type, code: st.code)).not_to be_valid
      end

      it 'is invalid with duplicate name' do
        st = create(:service_type)
        expect(build(:service_type, name: st.name)).not_to be_valid
      end
    end
  end
end